# norootforbuild

%define		soname	10

Name:		libmicrohttpd
Version:	0.9.10
Release:	1.pm.1.1

Summary:	Small Embeddable HTTP Server Library
License:	GNU LGPL v2.1
Group:		Productivity/Networking/Web/Servers
Url:		http://gnunet.org/libmicrohttpd/

Source:		http://ftpmirror.gnu.org/libmicrohttpd/%{name}-%{version}.tar.gz

BuildRoot:	%{_tmppath}/%{name}-%{version}-build

BuildRequires:	libcurl-devel
BuildRequires:	libgcrypt-devel
BuildRequires:	libtasn1-devel


%description
GNU libmicrohttpd is a small C library that is supposed to make it easy to run an HTTP server as part of another application. GNU libmicrohttpd is free software and part of the GNU project. Key features that distinguish libmicrohttpd from other projects are:

    * C library: fast and small
    * API is simple, expressive and fully reentrant
    * Implementation is http 1.1 compliant
    * HTTP server can listen on multiple ports
    * Support for IPv6
    * Support for incremental processing of POST data
    * Creates binary of only 30k (without TLS/SSL support)
    * Three different threading models
    * Supported platforms include GNU/Linux, FreeBSD, OpenBSD, NetBSD, OS X, W32, Symbian and z/OS
    * Optional support for SSL3 and TLS (requires libgcrypt)

libmicrohttpd was started because the author needed an easy way to add a concurrent HTTP server to other projects. Existing alternatives were either non-free, not reentrant, standalone, of terrible code quality or a combination thereof. Do not use libmicrohttpd if you are looking for a standalone http server, there are many other projects out there that provide that kind of functionality already. However, if you want to be able to serve simple WWW pages from within your C or C++ application, check it out.

%package -n %{name}%{soname}
Group:		System/Libraries
PreReq:		glibc
Summary:	Small Embeddable HTTP Server Library

%description -n %{name}%{soname}
GNU libmicrohttpd is a small C library that is supposed to make it easy to run an HTTP server as part of another application. GNU libmicrohttpd is free software and part of the GNU project. Key features that distinguish libmicrohttpd from other projects are:

    * C library: fast and small
    * API is simple, expressive and fully reentrant
    * Implementation is http 1.1 compliant
    * HTTP server can listen on multiple ports
    * Support for IPv6
    * Support for incremental processing of POST data
    * Creates binary of only 30k (without TLS/SSL support)
    * Three different threading models
    * Supported platforms include GNU/Linux, FreeBSD, OpenBSD, NetBSD, OS X, W32, Symbian and z/OS
    * Optional support for SSL3 and TLS (requires libgcrypt)

libmicrohttpd was started because the author needed an easy way to add a concurrent HTTP server to other projects. Existing alternatives were either non-free, not reentrant, standalone, of terrible code quality or a combination thereof. Do not use libmicrohttpd if you are looking for a standalone http server, there are many other projects out there that provide that kind of functionality already. However, if you want to be able to serve simple WWW pages from within your C or C++ application, check it out.

%package devel
Group:		Development/Libraries/C and C++
Requires:	%{name}%{soname} = %{version}
PreReq:		info
Summary:	Small Embeddable HTTP Server Library

%description devel
GNU libmicrohttpd is a small C library that is supposed to make it easy to run an HTTP server as part of another application. GNU libmicrohttpd is free software and part of the GNU project. Key features that distinguish libmicrohttpd from other projects are:

    * C library: fast and small
    * API is simple, expressive and fully reentrant
    * Implementation is http 1.1 compliant
    * HTTP server can listen on multiple ports
    * Support for IPv6
    * Support for incremental processing of POST data
    * Creates binary of only 30k (without TLS/SSL support)
    * Three different threading models
    * Supported platforms include GNU/Linux, FreeBSD, OpenBSD, NetBSD, OS X, W32, Symbian and z/OS
    * Optional support for SSL3 and TLS (requires libgcrypt)

libmicrohttpd was started because the author needed an easy way to add a concurrent HTTP server to other projects. Existing alternatives were either non-free, not reentrant, standalone, of terrible code quality or a combination thereof. Do not use libmicrohttpd if you are looking for a standalone http server, there are many other projects out there that provide that kind of functionality already. However, if you want to be able to serve simple WWW pages from within your C or C++ application, check it out.


%prep
%setup -q

%build
%configure --disable-static \
	--enable-curl \
	--enable-messages \
	--enable-https \
	--enable-client-side
%__make %{?_smp_mflags}

%install
%makeinstall
find %{buildroot} -name *.la -exec %__rm {} \;

# Some tests fail due to some issue in gnutls
#%check
#%__make %{?_smp_mflags} check

%post -n %{name}%{soname} -p /sbin/ldconfig

%post devel
%install_info --info-dir=%{_infodir} %{_infodir}/microhttpd.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/microhttpd-tutorial.info.gz

%postun -n %{name}%{soname} -p /sbin/ldconfig

%postun devel
%install_info_delete --info-dir=%{_infodir} %{_infodir}/microhttpd.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/microhttpd-tutorial.info.gz


%clean
%__rm -rf %{buildroot}


%files -n %{name}%{soname}
%defattr(-,root,root)
%{_libdir}/libmicrohttpd.so.%{soname}*

%files devel
%defattr(-,root,root)
%{_includedir}/microhttpd.h
%{_libdir}/libmicrohttpd.so
%{_libdir}/pkgconfig/libmicrohttpd.pc
%{_infodir}/microhttpd*
%{_mandir}/man3/libmicrohttpd.3*


%changelog
* Thu Apr 28 2011 detlef@links2linux.de
- new upstream version <0.9.10>
* Sat Apr  2 2011 detlef@links2linux.de
- new upstream version <0.9.9>
* Fri Mar  4 2011 detlef@links2linux.de
- new upstream version <0.9.8>
  * This release adds support for server-initiated connections (with a new API
    call). By avoiding the use of pthread signals, portability is improved. A
    portability issue for digest... authentication was fixed. Large file
    transfers (larger than 2 GB) with sendfile on 32-bit systems should now
    work; kernel-level sendfile failures are now managed by falling back to
    standard send calls. The tutorial was updated with an example of how to
    manage sessions
* Sun Feb 20 2011 detlef@links2linux.de
- new upstream version <0.9.7>
* Sun Jan 30 2011 detlef@links2linux.de
- new upstream version <0.9.6>
* Fri Jan 14 2011 detlef@links2linux.de
- new upstream version <0.9.5>
* Sun Dec 26 2010 detlef@links2linux.de
- new upstream version <0.9.4>
* Wed Nov 24 2010 detlef@links2linux.de
- new upstream version <0.9.3>
* Sun Oct 17 2010 detlef@links2linux.de
- new upstream version <0.9.2>
* Sun Sep 12 2010 detlef@links2linux.de
- new upstream version <0.9.1>
* Tue Aug  3 2010 detlef@links2linux.de
- new upstream version <0.9.0>
* Mon Jun 28 2010 detlef@links2linux.de
- new upstream version <0.4.6>
* Tue Feb  2 2010 bitshuffler #suse@irc.freenode.org
- Updated to 0.4.5.
* Sun Jan 17 2010 bitshuffler #suse@irc.freenode.org
- Initial RPM.
